/**
 * Ecrivez une fonction permettant la recherche dichotomique binary_search
 * qui renverra un pointeur constant sur l'élément trouvé ou NULL dans le cas contraire :
 * 1) faites une fonction classique recevant un tableau d'entier, le nombre d'éléments
 * et la clef de recherche,
const int* binary_search (const int* array, int n, int x) {
    const int* l = array, *hi = array + n, *mid;
    bool not_found = true;
    while (lo != hi && not_found) {
        mid = lo + (hi - lo) / 2;
        if (x == * mid) not_found = false;
        else if (x <= *mid) hi = mid;
        else lo = mid + 1;
    }
    return (not_found ? 0 : mid);
}
 * 2) templatiser la fonction de telle manière à ce que le type de données soit générique,
template <class T>
const T* binary_search (const T* array, int n, const T& x) {
    const T* lo = array, *hi = array + n, *mid;
    bool not_found = true;
    while (lo != hi && not_found) {
        mid = lo + (hi - lo) / 2;
        if (x == * mid) not_found = false;
        else if (x <= *mid) hi = mid;
        else lo = mid + 1;
    }
    return (not_found ? 0 : mid);
}
 * 3) modifier la valeur de retour NULL vers un pointeur après le dernier élément du container,
template <class T>
const T* binary_search (const T* array, int n, const T& x) {
    const T* lo = array, *hi = array + n, *mid;
    bool not_found = true;
    while (lo != hi && not_found) {
        mid = lo + (hi - lo) / 2;
        if (x == * mid) not_found = false;
        else if (x <= *mid) hi = mid;
        else lo = mid + 1;
    }
    return (not_found ? array + n : mid);
}
 * 4) remplacer le tableau par des pointeurs dans la philosophie des itérateurs first et last,
template <class T>
const T* binary_search (T* first, T* last, const T& value) {
    const T* lo = first, *hi = last, *mid;
    bool not_found = true;
    while (lo != hi && not_found) {
        mid = lo + (hi - lo) / 2;
        if (value == * mid) not_found = false;
        else if (value <= *mid) hi = mid;
        else lo = mid + 1;
    }
    return (not_found ? last : mid);
}
 * 5) spécifier le type des itérateurs comme des RandomAccessIterator, et donner une raison
 * de l'intérêt de ce type d'itérateurs,
 * et utiliser votre fonction dans un programme.
 */
#include <iostream>
template <class RandomAccessIterator, class T>
RandomAccessIterator binary_search (RandomAccessIterator first, RandomAccessIterator last, const T& value) {
    RandomAccessIterator not_found = last, mid;
    bool nf = true;
    while (first != last && nf) {
        mid = first + (last - first) / 2;
        if (value == *mid) {
            not_found = mid;
            nf = false;
        }
        else if (value < *mid) last = mid;
        else first = mid + 1;
    }
    return not_found;
}

int main ( ) {
    int x[5] = {1,10,35,43,50} ;
    int search_value = 50;
    int* i = binary_search (&x[0], &x[5], search_value);
    if ( i == &x[5] )
        std::cout << "value not found" << std::endl;
    else
        std::cout << "value found" << std::endl;
}
